"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.typeIn = typeIn;
exports.default = void 0;

var _jsdom = require("jsdom");

var _default = _jsdom.JSDOM;
exports.default = _default;

const _ref = new _jsdom.JSDOM('', {
  url: 'http://test.com/',
  pretendToBeVisual: true
}),
      window = _ref.window;

['self', 'document', 'Node', 'HTMLElement', 'DocumentFragment', 'DOMParser', 'XMLSerializer', 'NodeFilter', 'InputEvent', 'CustomEvent'].forEach(key => global[key] = window[key]);
/**
 * @private
 *
 * @param {HTMLElement} input
 * @param {String}      raw
 *
 * @emits {InputEvent} `input`
 *
 * @return {Promise}
 */

function typeIn(input, raw) {
  return Promise.all(Array.from(raw, data => new Promise(resolve => setTimeout(() => {
    input.value += data;
    input.dispatchEvent(new InputEvent('input', {
      bubbles: true,
      composed: true,
      data
    }));
    resolve();
  }))));
}
